/* Simple(st) QL/QDOS calculator with expression parser */

#include <stdio.h>
#include <math.h>
#include <val.h>

#define CONBUFLEN 260

int main() {
    char *userin, userinbuf[CONBUFLEN];
    int *rorre=0.;
    double result, x;

    x = 4*atan(1.e0); /* use x for the value of pi (3.14...) */
    printf("Simple QL calculator for evaluating expressions\n");
    printf("Use 'x' for value of pi, e.g. 2*sin(x/6)\n");
    printf("Simplecalc understands all the usual operators and functions such as\n");
    printf("+ - * /  ^ sin cos tan asn acs atn exp log\n");

    for (;;) {
    	printf(">");
        userin = gets(userinbuf);
        if (userin[0] == '\0' || !userin) {
        	printf("By...\n");
            exit(0);
        }
        result = val(userin,rorre,x,0.);
        if (*rorre)
		    printf("Error in expression\n");
		else
		    printf("%.14g\n",result);
    }
}

